/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { CreateCurrencyCommand } from '../models';
// @ts-ignore
import { CurrenciesModel } from '../models';
// @ts-ignore
import { CurrencyModel } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { SortCurrenciesCommand } from '../models';
// @ts-ignore
import { UpdateCurrencyCommand } from '../models';
/**
 * CurrenciesApi - axios parameter creator
 * @export
 */
export const CurrenciesApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Delete currency
         * @param {string} currencyId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CurrenciesCurrencyIdDelete: async (currencyId: string, isPermanent?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'currencyId' is not null or undefined
            assertParamExists('apiV1CurrenciesCurrencyIdDelete', 'currencyId', currencyId)
            const localVarPath = `/api/v1/currencies/{currencyId}`
                .replace(`{${"currencyId"}}`, encodeURIComponent(String(currencyId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (isPermanent !== undefined) {
                localVarQueryParameter['isPermanent'] = isPermanent;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get currency
         * @param {string} currencyId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CurrenciesCurrencyIdGet: async (currencyId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'currencyId' is not null or undefined
            assertParamExists('apiV1CurrenciesCurrencyIdGet', 'currencyId', currencyId)
            const localVarPath = `/api/v1/currencies/{currencyId}`
                .replace(`{${"currencyId"}}`, encodeURIComponent(String(currencyId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update currency
         * @param {string} currencyId 
         * @param {UpdateCurrencyCommand} [updateCurrencyCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CurrenciesCurrencyIdPut: async (currencyId: string, updateCurrencyCommand?: UpdateCurrencyCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'currencyId' is not null or undefined
            assertParamExists('apiV1CurrenciesCurrencyIdPut', 'currencyId', currencyId)
            const localVarPath = `/api/v1/currencies/{currencyId}`
                .replace(`{${"currencyId"}}`, encodeURIComponent(String(currencyId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateCurrencyCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Reactivate currency
         * @param {string} currencyId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CurrenciesCurrencyIdReactivatePut: async (currencyId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'currencyId' is not null or undefined
            assertParamExists('apiV1CurrenciesCurrencyIdReactivatePut', 'currencyId', currencyId)
            const localVarPath = `/api/v1/currencies/{currencyId}/reactivate`
                .replace(`{${"currencyId"}}`, encodeURIComponent(String(currencyId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get currencies
         * @param {string} [id] 
         * @param {string} [currencyCode] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CurrenciesGet: async (id?: string, currencyCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/currencies`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (id !== undefined) {
                localVarQueryParameter['Id'] = id;
            }

            if (currencyCode !== undefined) {
                localVarQueryParameter['CurrencyCode'] = currencyCode;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create currency
         * @param {CreateCurrencyCommand} [createCurrencyCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CurrenciesPost: async (createCurrencyCommand?: CreateCurrencyCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/currencies`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createCurrencyCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Sort currencies
         * @param {SortCurrenciesCommand} [sortCurrenciesCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CurrenciesSortPut: async (sortCurrenciesCommand?: SortCurrenciesCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/currencies/sort`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(sortCurrenciesCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * CurrenciesApi - functional programming interface
 * @export
 */
export const CurrenciesApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = CurrenciesApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Delete currency
         * @param {string} currencyId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1CurrenciesCurrencyIdDelete(currencyId: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1CurrenciesCurrencyIdDelete(currencyId, isPermanent, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get currency
         * @param {string} currencyId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1CurrenciesCurrencyIdGet(currencyId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CurrencyModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1CurrenciesCurrencyIdGet(currencyId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update currency
         * @param {string} currencyId 
         * @param {UpdateCurrencyCommand} [updateCurrencyCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1CurrenciesCurrencyIdPut(currencyId: string, updateCurrencyCommand?: UpdateCurrencyCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CurrencyModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1CurrenciesCurrencyIdPut(currencyId, updateCurrencyCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Reactivate currency
         * @param {string} currencyId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1CurrenciesCurrencyIdReactivatePut(currencyId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1CurrenciesCurrencyIdReactivatePut(currencyId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get currencies
         * @param {string} [id] 
         * @param {string} [currencyCode] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1CurrenciesGet(id?: string, currencyCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CurrenciesModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1CurrenciesGet(id, currencyCode, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create currency
         * @param {CreateCurrencyCommand} [createCurrencyCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1CurrenciesPost(createCurrencyCommand?: CreateCurrencyCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CurrencyModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1CurrenciesPost(createCurrencyCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Sort currencies
         * @param {SortCurrenciesCommand} [sortCurrenciesCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1CurrenciesSortPut(sortCurrenciesCommand?: SortCurrenciesCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1CurrenciesSortPut(sortCurrenciesCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * CurrenciesApi - factory interface
 * @export
 */
export const CurrenciesApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = CurrenciesApiFp(configuration)
    return {
        /**
         * 
         * @summary Delete currency
         * @param {string} currencyId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CurrenciesCurrencyIdDelete(currencyId: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1CurrenciesCurrencyIdDelete(currencyId, isPermanent, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get currency
         * @param {string} currencyId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CurrenciesCurrencyIdGet(currencyId: string, options?: any): AxiosPromise<CurrencyModel> {
            return localVarFp.apiV1CurrenciesCurrencyIdGet(currencyId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update currency
         * @param {string} currencyId 
         * @param {UpdateCurrencyCommand} [updateCurrencyCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CurrenciesCurrencyIdPut(currencyId: string, updateCurrencyCommand?: UpdateCurrencyCommand, options?: any): AxiosPromise<CurrencyModel> {
            return localVarFp.apiV1CurrenciesCurrencyIdPut(currencyId, updateCurrencyCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Reactivate currency
         * @param {string} currencyId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CurrenciesCurrencyIdReactivatePut(currencyId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1CurrenciesCurrencyIdReactivatePut(currencyId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get currencies
         * @param {string} [id] 
         * @param {string} [currencyCode] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CurrenciesGet(id?: string, currencyCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<CurrenciesModel> {
            return localVarFp.apiV1CurrenciesGet(id, currencyCode, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create currency
         * @param {CreateCurrencyCommand} [createCurrencyCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CurrenciesPost(createCurrencyCommand?: CreateCurrencyCommand, options?: any): AxiosPromise<CurrencyModel> {
            return localVarFp.apiV1CurrenciesPost(createCurrencyCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Sort currencies
         * @param {SortCurrenciesCommand} [sortCurrenciesCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CurrenciesSortPut(sortCurrenciesCommand?: SortCurrenciesCommand, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1CurrenciesSortPut(sortCurrenciesCommand, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1CurrenciesCurrencyIdDelete operation in CurrenciesApi.
 * @export
 * @interface CurrenciesApiApiV1CurrenciesCurrencyIdDeleteRequest
 */
export interface CurrenciesApiApiV1CurrenciesCurrencyIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof CurrenciesApiApiV1CurrenciesCurrencyIdDelete
     */
    readonly currencyId: string

    /**
     * 
     * @type {boolean}
     * @memberof CurrenciesApiApiV1CurrenciesCurrencyIdDelete
     */
    readonly isPermanent?: boolean
}

/**
 * Request parameters for apiV1CurrenciesCurrencyIdGet operation in CurrenciesApi.
 * @export
 * @interface CurrenciesApiApiV1CurrenciesCurrencyIdGetRequest
 */
export interface CurrenciesApiApiV1CurrenciesCurrencyIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof CurrenciesApiApiV1CurrenciesCurrencyIdGet
     */
    readonly currencyId: string
}

/**
 * Request parameters for apiV1CurrenciesCurrencyIdPut operation in CurrenciesApi.
 * @export
 * @interface CurrenciesApiApiV1CurrenciesCurrencyIdPutRequest
 */
export interface CurrenciesApiApiV1CurrenciesCurrencyIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof CurrenciesApiApiV1CurrenciesCurrencyIdPut
     */
    readonly currencyId: string

    /**
     * 
     * @type {UpdateCurrencyCommand}
     * @memberof CurrenciesApiApiV1CurrenciesCurrencyIdPut
     */
    readonly updateCurrencyCommand?: UpdateCurrencyCommand
}

/**
 * Request parameters for apiV1CurrenciesCurrencyIdReactivatePut operation in CurrenciesApi.
 * @export
 * @interface CurrenciesApiApiV1CurrenciesCurrencyIdReactivatePutRequest
 */
export interface CurrenciesApiApiV1CurrenciesCurrencyIdReactivatePutRequest {
    /**
     * 
     * @type {string}
     * @memberof CurrenciesApiApiV1CurrenciesCurrencyIdReactivatePut
     */
    readonly currencyId: string
}

/**
 * Request parameters for apiV1CurrenciesGet operation in CurrenciesApi.
 * @export
 * @interface CurrenciesApiApiV1CurrenciesGetRequest
 */
export interface CurrenciesApiApiV1CurrenciesGetRequest {
    /**
     * 
     * @type {string}
     * @memberof CurrenciesApiApiV1CurrenciesGet
     */
    readonly id?: string

    /**
     * 
     * @type {string}
     * @memberof CurrenciesApiApiV1CurrenciesGet
     */
    readonly currencyCode?: string

    /**
     * 
     * @type {number}
     * @memberof CurrenciesApiApiV1CurrenciesGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof CurrenciesApiApiV1CurrenciesGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof CurrenciesApiApiV1CurrenciesGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1CurrenciesPost operation in CurrenciesApi.
 * @export
 * @interface CurrenciesApiApiV1CurrenciesPostRequest
 */
export interface CurrenciesApiApiV1CurrenciesPostRequest {
    /**
     * 
     * @type {CreateCurrencyCommand}
     * @memberof CurrenciesApiApiV1CurrenciesPost
     */
    readonly createCurrencyCommand?: CreateCurrencyCommand
}

/**
 * Request parameters for apiV1CurrenciesSortPut operation in CurrenciesApi.
 * @export
 * @interface CurrenciesApiApiV1CurrenciesSortPutRequest
 */
export interface CurrenciesApiApiV1CurrenciesSortPutRequest {
    /**
     * 
     * @type {SortCurrenciesCommand}
     * @memberof CurrenciesApiApiV1CurrenciesSortPut
     */
    readonly sortCurrenciesCommand?: SortCurrenciesCommand
}

/**
 * CurrenciesApi - object-oriented interface
 * @export
 * @class CurrenciesApi
 * @extends {BaseAPI}
 */
export class CurrenciesApi extends BaseAPI {
    /**
     * 
     * @summary Delete currency
     * @param {CurrenciesApiApiV1CurrenciesCurrencyIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CurrenciesApi
     */
    public apiV1CurrenciesCurrencyIdDelete(requestParameters: CurrenciesApiApiV1CurrenciesCurrencyIdDeleteRequest, options?: AxiosRequestConfig) {
        return CurrenciesApiFp(this.configuration).apiV1CurrenciesCurrencyIdDelete(requestParameters.currencyId, requestParameters.isPermanent, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get currency
     * @param {CurrenciesApiApiV1CurrenciesCurrencyIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CurrenciesApi
     */
    public apiV1CurrenciesCurrencyIdGet(requestParameters: CurrenciesApiApiV1CurrenciesCurrencyIdGetRequest, options?: AxiosRequestConfig) {
        return CurrenciesApiFp(this.configuration).apiV1CurrenciesCurrencyIdGet(requestParameters.currencyId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update currency
     * @param {CurrenciesApiApiV1CurrenciesCurrencyIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CurrenciesApi
     */
    public apiV1CurrenciesCurrencyIdPut(requestParameters: CurrenciesApiApiV1CurrenciesCurrencyIdPutRequest, options?: AxiosRequestConfig) {
        return CurrenciesApiFp(this.configuration).apiV1CurrenciesCurrencyIdPut(requestParameters.currencyId, requestParameters.updateCurrencyCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Reactivate currency
     * @param {CurrenciesApiApiV1CurrenciesCurrencyIdReactivatePutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CurrenciesApi
     */
    public apiV1CurrenciesCurrencyIdReactivatePut(requestParameters: CurrenciesApiApiV1CurrenciesCurrencyIdReactivatePutRequest, options?: AxiosRequestConfig) {
        return CurrenciesApiFp(this.configuration).apiV1CurrenciesCurrencyIdReactivatePut(requestParameters.currencyId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get currencies
     * @param {CurrenciesApiApiV1CurrenciesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CurrenciesApi
     */
    public apiV1CurrenciesGet(requestParameters: CurrenciesApiApiV1CurrenciesGetRequest = {}, options?: AxiosRequestConfig) {
        return CurrenciesApiFp(this.configuration).apiV1CurrenciesGet(requestParameters.id, requestParameters.currencyCode, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create currency
     * @param {CurrenciesApiApiV1CurrenciesPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CurrenciesApi
     */
    public apiV1CurrenciesPost(requestParameters: CurrenciesApiApiV1CurrenciesPostRequest = {}, options?: AxiosRequestConfig) {
        return CurrenciesApiFp(this.configuration).apiV1CurrenciesPost(requestParameters.createCurrencyCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Sort currencies
     * @param {CurrenciesApiApiV1CurrenciesSortPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CurrenciesApi
     */
    public apiV1CurrenciesSortPut(requestParameters: CurrenciesApiApiV1CurrenciesSortPutRequest = {}, options?: AxiosRequestConfig) {
        return CurrenciesApiFp(this.configuration).apiV1CurrenciesSortPut(requestParameters.sortCurrenciesCommand, options).then((request) => request(this.axios, this.basePath));
    }
}
